unit Dictionary;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TDictionaryForm = class(TForm)
    MainMenu1: TMainMenu;
    miMenu: TMenuItem;
    miDictionaries: TMenuItem;
    miToMainMenu: TMenuItem;
    miManagement: TMenuItem;
    miInterviewer: TMenuItem;
    miExit: TMenuItem;
    miHunEng: TMenuItem;
    miEngHun: TMenuItem;
    miHelp: TMenuItem;
    Label1: TLabel;
    tbSearch: TEdit;
    Label2: TLabel;
    btExit: TButton;
    lbTranslate: TListBox;
    Label4: TLabel;
    Label3: TLabel;
    lbWords: TListBox;
    btOk: TBitBtn;
    StatusBar1: TStatusBar;
    //form esemnyek
    procedure FormClose(Sender: TObject; var Action: TCloseAction);  //for bezrsa
    //menukre katt
    procedure miExitClick(Sender: TObject);    //kilps
    procedure miHunEngClick(Sender: TObject);  //magya-angol sztrra vlts
    procedure miEngHunClick(Sender: TObject);  //angol-magyar sztrra vlts
    procedure miToMainMenuClick(Sender: TObject);  //vissza a fmenbe
    procedure miManagementClick(Sender: TObject);  //Karbantarts formra megy
    procedure miInterviewerClick(Sender: TObject);  //Tudsprba formra megy
    procedure miHelpClick(Sender: TObject);  //help elhozza
    //objektumokra katt
    procedure tbSearchChange(Sender: TObject);  //keresd sz megvltozik
    procedure lbWordsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);  //szavak kzt vltunk
    procedure lbWordsClick(Sender: TObject);  //szra katt
    procedure lbWordsDblClick(Sender: TObject);  //szra dupln katt
    procedure btOkClick(Sender: TObject);  //Ok gombra katt
    //segd eljrsok
    procedure BaseState();

  private
    { Private declarations }
    lastPos : integer; //az utols olyan sz indexe, ami mg nem megfelel (ezutn mr a j sz jn)
    f : text; //fjlok
  public
    { Public declarations }
  end;

var
  DictionaryForm: TDictionaryForm;
  
implementation

//milyen egyb formokat hasznlunk mg
uses Init, Management, Interviewer, Exit, Help;

{$R *.DFM}


//------------------------------------------  MENU  -------------------------------------------------------------


//Magyar-angol sztrra vltunk
//alapllapotba hozza a formokat (tbbet)
procedure TDictionaryForm.miHunEngClick(Sender: TObject);
begin
  miHunEng.Checked:=True;
  miEngHun.Checked:=False;
  Label1.Caption:='Magyar-Angol';
  Label3.Caption:='Magyar';
  Label4.Caption:='Angol';
  BaseState();
end;

//Angol-magyar sztrra vltunk
//alapllapotba hozza a formot
procedure TDictionaryForm.miEngHunClick(Sender: TObject);
begin
  miHunEng.checked:=False;
  miEngHun.checked:=True;
  Label1.Caption:='Angol-Magyar';
  Label3.Caption:='Angol';
  Label4.Caption:='Magyar';
  BaseState();
end;

//alapllapothoz egy kzs eljrs
procedure TDictionaryForm.BaseState();
begin
  tbSearch.Text:='';
  lbWords.Items.Clear;
  lbTranslate.Items.Clear;
  if(Visible) then tbSearch.SetFocus;
end;

//vissza a fmenbe
procedure TDictionaryForm.miToMainMenuClick(Sender: TObject);
begin
  DictionaryForm.Visible:=False;
  InitForm.Show();
end;

//Karbantarts formra mnk
procedure TDictionaryForm.miManagementClick(Sender: TObject);
begin
  if(miHunEng.Checked)
  then ManagementForm.miHunEng.Click
  else ManagementForm.miEngHun.Click;
  ManagementForm.Show();
  ManagementForm.tbWord.SetFocus;
end;

//Tudsprba formra mnk
procedure TDictionaryForm.miInterviewerClick(Sender: TObject);
begin
 miHunEng.checked:=true;
 miEngHun.checked:=False;
 DictionaryForm.Visible:=false;
 InterviewerForm.Show();
end;

//segtsg menre katt
procedure TDictionaryForm.miHelpClick(Sender: TObject);
begin
 with HelpForm do
  begin
   height:=395;
   memoDictionary.visible:=true;
   btOkDictionary.Visible:=true;
   Visible:=true;
   btOkDictionary.SetFocus;
  end;
end;

//kilps menre katt
procedure TDictionaryForm.miExitClick(Sender: TObject);
begin
  beep;
  ExitForm.Show();
end;


//-----------------------------------------  FUNKCIK  ------------------------------------------------------------


//keresend sz bersa
procedure TDictionaryForm.tbSearchChange(Sender: TObject);
  var s, word : string;  //bert sz
      i : integer;   //sz pozcija
      letter, letter2 : char;  //ezeket azonosnak tekintjk : a=, e=, ...
begin
DictionaryForm.lbTranslate.Clear;
//hibakezel blokk
try;
 word:=tbSearch.text;
 if word=''  then DictionaryForm.lbWords.Items.Clear;

 //ha csak egy bett tartalmaz -> betlti a szavakat (azzal kezddeket)
 if length(word)=1  then
  begin
   lbWords.Items.Clear;
   letter:=word[1];
   case letter of
    'a' : letter2:='';
    '' : letter2:='a';
    'e' : letter2:='';
    '' : letter2:='e';
    'i' : letter2:='';
    '' : letter2:='i';
    'o' : letter2:='';
    '' : letter2:='o';
    '' : letter2:='';
    '' : letter2:='';
    'u' : letter2:='';
    '' : letter2:='u';
    '' : letter2:='';
    '' : letter2:=''
    else letter2:='0';
   end;
   //melyik sztrbl
   if(miHunEng.Checked)
   then AssignFile(f,'Adat\m-a\magyar.dat')
   else AssignFile(f,'Adat\a-m\angol.dat');
   Reset(f); //flj  megnyitsa
   lastPos:=0;
   //beolvass: azzal a betvel kezddeket betesszk a listboxba
   repeat;
     Readln(f,s);
     if (s<>'') and ((s[1]=letter) or (s[1]=letter2))
     then lbWords.Items.Add(s)
     else if(lbWords.Items.count=0)
          then lastPos:=lastPos+1;
   until (s='') or ((lbWords.Items.Count<>0) and (s[1]>letter) and (s[1]>letter2));
   CloseFile(f); //fjllezrs
  end
 //ha mr tbb betbl ll: csak pozicionlunk a listboxban
 else if(length(word)>1) then
  begin
   i:=-1;
   Repeat; //kijells
    i:=i+1;
    if i=lbWords.Items.Count then i:=i-1;
   Until (word=Copy(lbWords.Items[i],1,length(tbSearch.Text))) or (i=lbWords.Items.count-1);
   lbWords.ItemIndex:=i;
  end;
except
  on EStringlistError do tbSearch.Text:='';  //hibakezels
end;
end;

//ha rkatt, akk berjuk a keres textboxba
procedure TDictionaryForm.lbWordsClick(Sender: TObject);
begin
  tbSearch.Text:=lbWords.Items.Strings[lbWords.ItemIndex];
end;

//duplakatt esetn megmutatja a fordtst
procedure TDictionaryForm.lbWordsDblClick(Sender: TObject);
 var i,c : integer;
     s, word, original : string;
begin
 lbTranslate.Items.Clear;
 c:=lbWords.ItemIndex;

 //melyik sztr
 if miHunEng.Checked
 then AssignFile(f,'Adat\m-a\angol.dat')
 else AssignFile(f,'Adat\a-m\magyar.dat');
 Reset(f);

 i:=-1;
 repeat; //betig olvas
  Readln(f,s);
  i:=i+1;
 until i>=lastPos;
 for i:=1 to c do //listbox-beli hely
  Readln(f,s);
 //tbb sz kilistzsa
 original := s; //ha vlsaztott sz, akkor az sszes jelents kell;
 repeat;
  //vessz pozci
  i:=pos(',',s);
  if i<>0  //ha van benne
  then begin word:=copy(s,1,i-1); delete(s,1,i); lbTranslate.Items.Add(word); end
  else begin i:=-5; lbTranslate.Items.Add(s); end;
 until i=-5;
 CloseFile(f);
 tbSearch.SetFocus;

 //ha szvlaszts van
 if btOk.Visible=true
 then
  begin
   InterviewerForm.count:=InterviewerForm.count+1;
   InterviewerForm.askedWords[InterviewerForm.count]:=True;
   InterviewerForm.words[InterviewerForm.count]:=lbWords.Items.Strings[lbWords.ItemIndex];
   InterviewerForm.translatedWords[InterviewerForm.count]:=original;
   Statusbar1.SimpleText:='Keresse meg, majd dupla kattintssal vlassza ki a szt!   ' + IntToStr(InterviewerForm.count)+'  vlasztott';
  end;
end;

//figyeli a gombnyomsokat a szavakon
procedure TDictionaryForm.lbWordsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 //ha enter, akkor szimullja, mintha dupln katt-unk volna
 if key=vk_return
 then lbWordsdblclick(sender);
end;

//ha kivlasztott elg szt, s OK-t nyom a tudsprba szvlasztskor
procedure TDictionaryForm.btOkClick(Sender: TObject);
begin
 DictionaryForm.Visible:=False;
 miMenu.Enabled:=true;
 miDictionaries.Enabled:=true;

 with  InterviewerForm do
  begin
    btFinish.Enabled:=true;
    btStart.Enabled:=true;
    btAnswer.Enabled:=false;
    tbAnswer.Enabled:=true;
    miSave.Enabled:=true;
    tbAnswer.CharCase:=eclowercase;
    btStart.SetFocus;
  end;
end;

//form bezrsa
procedure TDictionaryForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action:=caNone; // ne csinljon semmit (ne lpjen ki)
 beep;
 ExitForm.Show();
end;

end.
