unit Interviewer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, Buttons;

type
  TInterviewerForm = class(TForm)
    MainMenu1: TMainMenu;
    Men1: TMenuItem;
    miOptions: TMenuItem;
    miWords: TMenuItem;
    miNewWords: TMenuItem;
    miSave: TMenuItem;
    miLoad: TMenuItem;
    miChoosedWords: TMenuItem;
    miAllWords: TMenuItem;
    miDictionary: TMenuItem;
    miToMainMenu: TMenuItem;
    miExit: TMenuItem;
    miLanguage: TMenuItem;
    miHun: TMenuItem;
    miEng: TMenuItem;
    GroupBox1: TGroupBox;
    lbAskedWord: TLabel;
    Label2: TLabel;
    tbAnswer: TEdit;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    btFinish: TButton;
    btBack: TButton;
    btStart: TButton;
    btAnswer: TButton;
    Panel2: TPanel;
    Label10: TLabel;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    btOkStat: TBitBtn;
    Panel1: TPanel;
    btExit: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel5: TPanel;
    Panel6: TPanel;
    rbChoosedWords: TRadioButton;
    rbAllWords: TRadioButton;
    rbHun: TRadioButton;
    rbEng: TRadioButton;
    Label13: TLabel;
    miAddWord: TMenuItem;
    miHelp: TMenuItem;
    Panel3: TPanel;
    Label11: TLabel;
    Label12: TLabel;
    btOkAnswerState: TBitBtn;
    Panel4: TPanel;
    Label14: TLabel;
    btOkFile: TBitBtn;
    //form esemnyek
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    //menkre katt
    procedure miAddWordClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure miToMainMenuClick(Sender: TObject);
    procedure miSaveClick(Sender: TObject);
    procedure miLoadClick(Sender: TObject);
    procedure miHunClick(Sender: TObject);
    procedure miEngClick(Sender: TObject);
    procedure miNewWordsClick(Sender: TObject);
    procedure miAllWordsClick(Sender: TObject);
    procedure miHelpClick(Sender: TObject);
    //objektumokra katt
    procedure btStartClick(Sender: TObject);
    procedure btFinishClick(Sender: TObject);
    procedure btAnswerClick(Sender: TObject);
    procedure tbAnswerClick(Sender: TObject);
    procedure btOkAnswerStateClick(Sender: TObject);
    procedure btBackClick(Sender: TObject);
    procedure btOkFileClick(Sender: TObject);
    procedure btOkStatClick(Sender: TObject);
    procedure tbAnswerKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Panel1Exit(Sender: TObject);  //kezdopanel bezrdik
    //segd eljrsok
    procedure RadioButtonsClick(Sender: TObject);  //kezdpanelen lev radiobutton-k kzs esemnye
    procedure Choose();  //szvlaszts
    
  private
    { Private declarations }
    allCount, goodCount, wordPos, result : integer;
    actDir : string;
    f, g : text; //fjlok
  public
    { Public declarations }
    //Vlasztott szavak miatt kell, h lthat legyen a DictionaryForm-rl is
    count : integer; //szavak szma
    words, translatedWords : array[1..100000] of string;  //szavak s fordtsuk listja
    askedWords : array[1..100000] of boolean; //szamonkrt szavak listja (melyik nem volt mg: True - false)
  end;

var
  InterviewerForm: TInterviewerForm;

implementation

uses Dictionary, Exit, Help, Init;

{$R *.DFM}


//------------------------------------------  MENU  -------------------------------------------------------------


//magyar-angol sztrra vlt
procedure TInterviewerForm.miHunClick(Sender: TObject);
begin
 miHun.checked:=true;
 miEng.checked:=False;
 if(miChoosedWords.checked)
 then miNewWordsClick(Sender)
 else miAllWordsClick(Sender);
end;

//angol-magyar sztrra vlt
procedure TInterviewerForm.miEngClick(Sender: TObject);  //nyelv
begin
 miHun.checked:=False;
 miEng.checked:=True;
 if(miChoosedWords.checked)
 then miNewWordsClick(Sender)
 else miAllWordsClick(Sender);
end;

//uj szavak menre katt
procedure TInterviewerForm.miNewWordsClick(Sender: TObject);
 var i : integer;
begin
 //Labelek belltsa
 if miEng.checked
 then label13.Caption:='Angol szmonkrs'
 else label13.Caption:='Magyar szmonkrs';
 Label8.Caption:='Vlasztott szavak';
 miChoosedWords.Checked:=True;
 miAllWords.Checked:=False;
 miAddWord.Enabled:=True;
 //Nullzunk
 for i:=1 to count do
  begin
   words[i]:='';
   translatedWords[i]:='';
   askedWords[i]:=True;
  end;
 count:=0;
 //felvesszk a szavakat
 Choose();
end;

//sz felvtele
procedure TInterviewerForm.miAddWordClick(Sender: TObject);
begin
 Choose();
end;

//kilps menre katt
procedure TInterviewerForm.miExitClick(Sender: TObject);
begin
 ExitForm.Visible:=False;
 beep;
 ExitForm.Show();
end;

//segtsg menre katt
procedure TInterviewerForm.miHelpClick(Sender: TObject);
begin
 with HelpForm do
  begin
   btOkInterviewer.Visible:=true;
   MemoInterviewer.Visible:=true;
   height:=468;
   Show();
   btOkInterviewer.SetFocus;
  end;
end;

//vissza a fmenbe katt
procedure TInterviewerForm.miToMainMenuClick(Sender: TObject);
begin
 panel1.Visible:=true;
 label8.Caption:='';
 rbHun.checked:=false;
 rbEng.checked:=false;
 rbChoosedWords.checked:=false;
 rbAllWords.checked:=false;
 btFinish.Enabled:=False;
 btStart.Enabled:=False;
 btAnswer.Enabled:=False;
 DictionaryForm.btOk.Visible:=false;
 DictionaryForm.btExit.Visible:=true;
 InterviewerForm.Visible:=false;
 InitForm.Show();
end;

//szavak mentsre katt
//kirjuk fljba a mentett szavakat
procedure TInterviewerForm.miSaveClick(Sender: TObject);
  var i : integer;
begin
  SetCurrentDir(actDir); //alapkonyvtr belltsa
  //melyik sztr
  if miHun.checked
  then Savedialog1.InitialDir:='adat\ments\magyar'
  else Savedialog1.InitialDir:='adat\ments\angol';

  //ha nincs sz
  if(count=0) then
   begin
    Label14.Caption:='Nincs kivlasztott sz!';
    Panel4.Visible:=true;
    btOkFile.setfocus;
   end
  else if(savedialog1.Execute)  //savedialog futtatsa
  then
   begin
    rewrite(f,savedialog1.filename);
    for i:=1 to count do
     writeln(f,words[i] + ';' + translatedWords[i]);
    closeFile(f);
    Label14.Caption:='Ments megtrtnt!';
    Panel4.Visible:=true;
    btOkFile.setfocus;
    SetCurrentDir(actDir);
   end;
end;

//szavak betltse katt
procedure TInterviewerForm.miLoadClick(Sender: TObject);
 var i,j : integer;
     s : string; //olvasshoz hasznlt segdvltoz
begin
 SetCurrentDir(actDir);
 Opendialog1.FileName:='';

 //melyik sztr
 if miHun.checked
 then Opendialog1.InitialDir:='adat\ments\magyar'
 else Opendialog1.InitialDir:='adat\ments\angol';

 //opendialog futtatsa
 if opendialog1.execute
 then  begin
  {$I-}  //ltezik-e
   AssignFile(f,opendialog1.filename);
   Reset(f);
  {$I+}
    If IOResult=0
    then begin
           //vltozk nullzsa
           for i:=1 to count do
            begin
             words[i]:='';
             translatedWords[i]:='';
             askedWords[i]:=True;
            end;
           
           //feltltjk a tmbbe
           AssignFile(f,opendialog1.filename);
           reset(f);
           i:=0;
           repeat;
            i:=i+1;
            readln(f,s); //mg szt kell vlasztani a szt a jelentseitl
            j:=pos(';',s);
            if(j<>0)  //ha van benne (mindig lennie kell)
            then begin words[i]:=copy(s,1,j-1); delete(s,1,j); translatedWords[i]:= s; askedWords[i]:=True; end
            else i:=i-1; //ha mgsem lenne, akk hibs -> kihagyjuk ezt a szt
           until s='';
           count := i; //azrt nem kell levonni 1-et, mert az uccs s res lesz (s=''), s akk az else g levonja
          closeFile(f);

          btFinish.Enabled:=true;
          btStart.Enabled:=true;
          btAnswer.Enabled:=true;
          miOptions.Enabled:=true;
          miLanguage.Enabled:=true;
          miSave.Enabled:=true;
          tbAnswer.Enabled:=true;
          tbAnswer.text:='';
          Label14.Caption:='Betlts megtrtnt!';
         end
     else label14.Caption:='A file nem ltezik!';
     label8.caption:='Vlasztott szavak';
     Panel4.Visible:=true;
     btOkFile.setfocus;
     SetCurrentDir(actDir);
   end;
end;


//-----------------------------------------  FUNKCIK  ------------------------------------------------------------


//amikor megjelenika form ez lefut
procedure TInterviewerForm.FormShow(Sender: TObject);
 var i : integer;
begin
  //vltozk alapllapotba hozsa
  actDir:=GetCurrentDir;
  for i:=1 to count do
   begin
    words[i]:='';
    translatedWords[i]:='';
   end;
  count:=0;
  //Form alapllapotba hozsa
  lbAskedWord.Caption:='';
  Label4.Caption:='0/0';
  Label5.Caption:='0%';
  tbAnswer.Text:='';
  tbAnswer.CharCase:=eclowercase;
  panel3.Visible:=False;
  panel2.Visible:=false;
  //Vlaszt panel elksztse
  panel1.Visible:=true;
  label8.Caption:='';
  rbEng.checked:=false;
  rbHun.checked:=false;
  rbChoosedWords.checked:=false;
  rbAllWords.checked:=false;
  //gombok letiltsa
  btFinish.Enabled:=False;
  btStart.Enabled:=False;
  btAnswer.Enabled:=False;
  //menk letiltsa
  miLanguage.Enabled:=False;
  miOptions.Enabled:=False;
  miWords.Enabled:=False;
end;

//indts gombra katt
procedure TInterviewerForm.btStartClick(Sender: TObject);
  var i,c : integer;
begin
 btStart.Enabled:=false;
 miOptions.Enabled:=false;
 miLanguage.Enabled:=false;
 allCount:=0;
 goodCount:=0;

 if count=0  //ha nincs sz
 then begin
       tbAnswer.CharCase:=ecnormal;
       tbAnswer.text:='Krem vlasszon szavakat!';
       btAnswer.Enabled:=False;
       btFinish.Enabled:=False;
       miSave.Enabled:=False;
      end
 else
  begin
   tbAnswer.Text:='';
   for i:=1 to count do
    askedWords[i]:=True;
   repeat;
    randomize; //szvlaszts
    c:=random(count)+1;
   until askedWords[c]<>False;
   askedWords[c]:=False;
   wordPos:=c;
   lbAskedWord.caption:=words[c];
   goodCount:=0;
   allCount:=1;
   result:=0;
   tbAnswer.SetFocus;
  end;
end;

//befejezs gombra katt
procedure TInterviewerForm.btFinishClick(Sender: TObject);
begin
if lbAskedWord.caption<>''
then begin  //rtkels
      if result>=85 then Label10.Caption:='Kivl teljestmny!';
      if (85>result) and (result>=70) then Label10.Caption:='J teljestmny!';
      if (70>result) and (result>=55) then Label10.Caption:='Kzepes teljestmny!';
      if (55>result) and (result>=40) then Label10.Caption:='Gyenge teljestmny!';
      if result<40 then Label10.Caption:='Rossz teljestmny!';
      if (result=0) and (allCount-1=0) then label10.Caption:='Nincs eredmnyed!';
      Panel2.Visible:=true;
      Label3.Caption:=Label4.caption;
      Label7.Caption:=Label5.Caption;
      lbAskedWord.Caption:='';
      Label4.Caption:='0/0';
      Label5.Caption:='0%';
      tbAnswer.Text:='';
      btOkStat.SetFocus;
      btStart.Enabled:=true;

      miOptions.Enabled:=true;
      miLanguage.Enabled:=true;
     end;
end;

//Mehet gombra katt
procedure TInterviewerForm.btAnswerClick(Sender: TObject);
 var i : integer;
     word,s : string;
begin
if lbAskedWord.caption<>'' then
 begin
  if (tbAnswer.text='') or (tbAnswer.text='rja ide a vlaszt!')
  then begin tbAnswer.CharCase:=ecNormal; tbAnswer.text:='rja ide a vlaszt!'; end
  else begin
   s:=translatedWords[wordPos];
   //ha tbb fordtsa is van
   repeat;
    i:=pos(',',s);
    if i<>0
    then begin word:=copy(s,1,i-1); delete(s,1,i); end
    else begin i:=-5; word:=s; end;
    if tbAnswer.text=word
    then begin
          Label11.Caption:='Helyes!!!';
          goodCount:=goodCount+1;
          label12.Caption:='gyes vagy!';
          i:=-5;
         end
    else begin
          Label11.Caption:='Helytelen';
          label12.Caption:=word
         end;
   until i=-5;

   result:=round((goodCount/allCount)*100);
   Label4.Caption:=IntToStr(goodCount)+'/'+IntToStr(allCount);
   Label5.Caption:=IntTostr(result)+'%';
   panel3.visible:=true;
   btAnswer.Enabled:=False;
   btOkAnswerState.SetFocus;
       end;
 end;
end;

procedure TInterviewerForm.tbAnswerKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 if (tbAnswer.text<>'') and (key=vk_return) and (lbAskedWord.Caption<>'')
 then btAnswerclick(sender);
end;

//Ha belekatt s az van benne, h rja ide.., akk ezt trli
procedure TInterviewerForm.tbAnswerClick(Sender: TObject);
begin
  if(tbAnswer.text='rja ide a vlaszt!')
  then begin tbAnswer.text:=''; tbAnswer.CharCase:=eclowercase; end;
end;

//Vlasz rtkelse panelen a Rendben gombra katt
procedure TInterviewerForm.btOkAnswerStateClick(Sender: TObject);
 var c : integer;
begin
Panel3.Visible:=False;
if allCount<count
then begin
      allCount:=allCount+1; //szavak szmolsa
      repeat;  //j sz
       randomize;
       c:=random(count)+1;
      until askedWords[c]<>False;
      askedWords[c]:=False;
      wordPos:=c;
      lbAskedWord.caption:=words[c];
      tbAnswer.text:='';
      tbAnswer.SetFocus;
     end
else btFinish.Click; //befejezs
btAnswer.Enabled:=true;
end;

//statisztika panelen az OK gombra katt
procedure TInterviewerForm.btOkStatClick(Sender: TObject);
begin
  Panel2.Visible:=False;
end;

//vissza gombr katt
procedure TInterviewerForm.btBackClick(Sender: TObject);
begin
 with DictionaryForm do
  begin
   if(InterviewerForm.miHun.Checked)
   then miEngHun.Click
   else miHunEng.Click;
   btOk.Visible:=False;
   btExit.Visible:=True;
   InterviewerForm.Visible:=False;
   Show();
   tbSearch.SetFocus;
   StatusBar1.SimpleText:='';
   StatusBar1.SimpleText:='rja be a keresett szt, majd kattintson rajta dupln!';
  end;
end;

//Szvlaszts
procedure TInterviewerForm.Choose();
begin
 //szavak kivlasztsnak elksztse
 with DictionaryForm do
  begin
   btExit.Visible:=False;
   btOk.Visible:=True;
   miMenu.Enabled:=false;
   miDictionaries.Enabled:=false;
   Show();
   tbSearch.SetFocus;
   StatusBar1.SimpleText:='';
   Statusbar1.SimpleText:='Keresse meg, majd dupla kattintssal vlassza ki a szt!  ' + IntToStr(count) + ' vlasztott';
   if(InterviewerForm.miHun.checked)
   then miEngHun.Click
   else miHunEng.Click;
  end;
end;

//Vletlen szer szavak
procedure TInterviewerForm.miAllWordsClick(Sender: TObject);
 var s,sz : string;
begin
 if miEng.checked
 then label13.Caption:='Angol szmonkrs'
 else label13.Caption:='Magyar szmonkrs';
 Label8.Caption:='Vletlenszer szavak';
 miChoosedWords.Checked:=False;
 miAllWords.Checked:=True;
 btFinish.Enabled:=true;
 btStart.Enabled:=true;
 btAnswer.Enabled:=true;
 tbAnswer.Enabled:=true;
 miAddWord.Enabled:=False;

 //hozzrendeljk a fjlokat
 if miEng.checked
 then begin AssignFile(f,'Adat\m-a\magyar.dat'); AssignFile(g,'Adat\m-a\angol.dat'); end
 else begin AssignFile(f,'Adat\a-m\angol.dat');  AssignFile(g,'Adat\a-m\magyar.dat'); end;
 //megnyitjuk ket
 Reset(f);
 Reset(g);
 //majd feltltjk a tmbket
 count:=0;
 repeat;
  Readln(f,s);
  Readln(g,sz);
  count:=count+1;
  words[count]:=s;
  translatedWords[count]:=sz;
  askedWords[count]:=True;
 until s='';
 count:=count-1;
 CloseFile(f);
end;

//OK gombra katt
procedure TInterviewerForm.btOkFileClick(Sender: TObject);
begin
 Panel4.Visible:=false;
 tbAnswer.setFocus;
end;

//mikor tnjn el a kezdeti panel (ha mindenbl vlasztott)
procedure TInterviewerForm.RadioButtonsClick(Sender: TObject);
begin
 if (rbHun.checked or rbEng.checked) and (rbChoosedWords.Checked or rbAllWords.Checked)
 then panel1.Visible:=False;
end;

//a kezdeti panel eltnik
procedure TInterviewerForm.Panel1Exit(Sender: TObject);
begin
 miChoosedWords.Checked := rbChoosedWords.Checked;
 if(rbHun.checked)
 then miHun.Click
 else miEng.Click;
 miLanguage.Enabled:=true;
 miOptions.Enabled:=true;
 miWords.Enabled:=true;
end;

//bezrja a formot
procedure TInterviewerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action:=caNone;
 beep;
 ExitForm.Show();
end;

end.
