unit Management;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Buttons, ExtCtrls;

type
  TManagementForm = class(TForm)
    MainMenu1: TMainMenu;
    Men1: TMenuItem;
    Sztrak1: TMenuItem;
    miBackToMain: TMenuItem;
    miExit: TMenuItem;
    miHunEng: TMenuItem;
    miEngHun: TMenuItem;
    miBack: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    tbWord: TEdit;
    tbTranslatedWord: TEdit;
    btAdd: TButton;
    btBack: TButton;
    btDel: TButton;
    btOk: TBitBtn;
    //form esemnyek
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    //menure katt
    procedure miHunEngClick(Sender: TObject);
    procedure miEngHunClick(Sender: TObject);
    procedure miBackToMainClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    //objektumokra katt
    procedure tbWordChange(Sender: TObject);
    procedure tbTranslatedWordChange(Sender: TObject);
    procedure btAddClick(Sender: TObject);
    procedure btDelClick(Sender: TObject);
    procedure btBackClick(Sender: TObject);
    procedure btOkClick(Sender: TObject);
    //segd eljrsok
    procedure BaseState();
    procedure BaseWords();
    procedure Beolvas();
    procedure Add();
    procedure Swap();

  private
    { Private declarations }
    f,g : text; //fjlok
    words, translatedWords : array[1..100000] of string; //szavak listja
  public
    { Public declarations }
  end;

var
  ManagementForm: TManagementForm;

implementation

uses Dictionary, Exit;

{$R *.DFM}

//------------------------------------------  MENU  -------------------------------------------------------------

//magyar-angol sztrra vlt
procedure TManagementForm.miHunEngClick(Sender: TObject);
begin
  Label1.Caption:='Magyar-Angol';
  miHunEng.checked:=True;
  miEngHun.checked:=False;
  Label2.Caption:='Krem a magyar szt:';
  Label3.Caption:='Krem az angol szt:';
  BaseState();
end;

//angol-magyar sztrra vlt
procedure TManagementForm.miEngHunClick(Sender: TObject);
begin
  Label1.Caption:='Angol-Magyar';
  miHunEng.checked:=False;
  miEngHun.checked:=True;
  Label2.Caption:='Krem az angol szt:';
  Label3.Caption:='Krem a magyar szt:';
  BaseState();
end;

procedure TManagementForm.BaseState();
begin
  tbWord.Text:='';
  tbTranslatedWord.text:='';
  if(Visible) then tbWord.SetFocus;
end;

//vissza a fmenbe
procedure TManagementForm.miBackToMainClick(Sender: TObject);
begin
  ManagementForm.Visible:=False;
  DictionaryForm.miToMainMenu.Click;
end;

//kilps
procedure TManagementForm.miExitClick(Sender: TObject);
begin
 beep;
 ExitForm.Show();
end;


//-----------------------------------------  FUNKCIK  ------------------------------------------------------------


//az els szvegdoboz megvltozik (ami a felvend sz)
procedure TManagementForm.tbWordChange(Sender: TObject);
 var i : byte;
     s : string;
begin
 for i:=1 to length(tbWord.text) do
 begin
  s:=tbWord.text[i];
  if ((s>='a') and (s<='z')) or (s=' ') or (s='-')
  then
  else tbWord.text:=copy(tbWord.text,1,i-1)+copy(tbWord.text,i+1,length(tbWord.text));
 end;

 //ha van bent vmi
 if(tbWord.Text<>'')
 then
  begin
   btDel.Enabled:=true;
   if (tbTranslatedWord.Text<>'') then btAdd.Enabled:=true;
  end
 //ha nincs
 else
  begin
   btAdd.Enabled:=false;
   btDel.Enabled:=false;
  end;
end;

//ha a msodik szvegdoboz megvltozik (a felvend sz fordtsa)
procedure TManagementForm.tbTranslatedWordChange(Sender: TObject);
 var s : string;
     i : byte;
begin
 for i:=1 to length(tbTranslatedWord.text) do
 begin
  s:=tbTranslatedWord.text[i];
  if ((s>='a') and (s<='z')) or (s=' ') or (s='-')
  then
  else tbTranslatedWord.text:=copy(tbTranslatedWord.text,1,i-1)+copy(tbTranslatedWord.text,i+1,length(tbTranslatedWord.text));
 end;

 //ha mindkettben van vmi
 if (tbWord.Text<>'') and (tbTranslatedWord.Text<>'')
 then btAdd.Enabled:=True
 else btAdd.Enabled:=False;
end;

//segd eljrs, sszes szt beolvassa egy tmbbe, s a jelentst is
Procedure TManagementForm.Beolvas();
  var word : string;
      s,sz : string; //olvasshoz, rshoz hasznlt segdvltozk
      i : integer;
begin
 word:=tbWord.text;
// letter:=word[1];
 DictionaryForm.lbWords.Items.Clear;
 
 //melyik sztr
 if miHunEng.checked
 then begin AssignFile(f,'Adat\m-a\magyar.dat'); AssignFile(g,'Adat\m-a\angol.dat'); end
 else begin AssignFile(f,'Adat\a-m\angol.dat'); AssignFile(g,'Adat\a-m\magyar.dat'); end;

 //a Dictionary form listbox-ait tlti fel
 Reset(f);
 Reset(g);
 i:=0;
 repeat;
  i:=i+1;
  Readln(f,s);
  Readln(g,sz);
  DictionaryForm.lbWords.Items.Add(s);
  words[i]:=s;
  translatedWords[i]:=sz;
 until words[i]='';
 CloseFile(f);
 CloseFile(g);
end;

procedure TManagementForm.btAddClick(Sender: TObject); //bvts
begin
  //az aktullis sztrhoz hozzadja
  Add();
  //hozzadjuk a msikhoz is, h szinkronban legyen
  Swap();
  Add();
  Swap();  //majd minden vissza
  //jelezzk, h sikeres volt
  Label4.Caption:='Bvts megtrtnt!';
end;

procedure TManagementForm.Swap();
var tmp : string;
begin
  //majd a msik sztrhoz is
  tmp:= tbWord.Text;
  tbWord.Text := tbTranslatedWord.Text;
  tbTranslatedWord.Text := tmp;
  miHunEng.Checked := not miHunEng.Checked;
  miEngHun.Checked := miHunEng.Checked;
end;

procedure TManagementForm.Add();
var word : string;
    i,c : integer;
begin
 Beolvas();
 word:=tbWord.text;
 DictionaryForm.lbWords.Items.Add(word);
 c:=DictionaryForm.lbWords.Items.IndexOf(word);  //a sz helye

 //addig jrarjuk a fjlt
 rewrite(f);
 rewrite(g);
 for i:=1 to c-1 do
  begin
   writeln(f,words[i]);
   writeln(g,translatedWords[i]);
  end;

 //beillesztjk a szt s a fordtst (figyelnk arra, ha mr ltezik a sz)
 if tbWord.text<>words[c]
 then begin writeln(f,tbWord.text); writeln(g,tbTranslatedWord.text); i:=c-1; end
 else begin writeln(f,words[c]); writeln(g,(translatedWords[c] + ',' + tbTranslatedWord.text)); i:=c; end;

 //folyatatjuk a tbbi szval
 repeat;
  i:=i+1;
  writeln(f,words[i]);
  writeln(g,translatedWords[i]);
 until words[i]='';
 CloseFile(f);
 CloseFile(g);

 //alapllapotba hozzuk a hasznlt vltozinkat
 BaseWords();
end;

//sz trlse
procedure TManagementForm.btDelClick(Sender: TObject);
  var szo : string;
      i,c : integer;
begin
Beolvas();
szo:=tbWord.text;
c:=DictionaryForm.lbWords.Items.IndexOf(szo);  //a sz indexe
if c<>-1
then begin
      rewrite(f);
      rewrite(g);
      //(c-1)-ig
      for i:=1 to c-1 do
        begin
         writeln(f,words[i]);
         writeln(g,translatedWords[i]);
        end;
      //(c+1)-ig  
      i:=c;
      repeat;
       i:=i+1;
       writeln(f,words[i]);
       writeln(g,translatedWords[i]);
      until words[i]='';
      CloseFile(f);
      CloseFile(g);
      Label4.Caption:='Trls megtrtnt!';
     end
else Label4.Caption:='Nincs ilyen sz!';

//alapllapotba hozzuk a hasznlt vltozkat
BaseWords();
end;

procedure TManagementForm.BaseWords();
 var i : integer;
begin
//alapllapotba hozzuk a hasznlt vltozinkat
 i:=0;
 Repeat;
  i:=i+1;
  words[i]:='';
  translatedWords[i]:='';
 until words[i]='';
 Panel1.Visible:=true;
end;

//vissza gombra katt
procedure TManagementForm.btBackClick(Sender: TObject);
begin
  if(miHunEng.Checked)
  then DictionaryForm.miHunEng.Click
  else DictionaryForm.miEngHun.Click;
  ManagementForm.Visible:=false;
end;

//a bvts megtrtnt panelen lev OK gombra katt
procedure TManagementForm.btOkClick(Sender: TObject);
begin
 Panel1.Visible:=false;
 tbWord.Text:='';
 tbTranslatedWord.text:='';
 tbWord.SetFocus;
end;

//bezrja a formot
procedure TManagementForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action:=caNone;
 beep;
 ExitForm.Show();
end;

end.
